10  REM program calculates line and stub lengths for source and load matching networks for transistor amplifier stage
20  REM program then calculates frequency response of amplifier
30  REM PROGRAM SAVED AS "AMP3"
35  REM MARCUS STALOFF   608 NO. WASHINGTON ST.  MOORESTOWN, NJ 08057
40  DIM F(110),IL(110),RL(110),IR(110),RO(110)
50  PRINT"":PRINT""
60  PRINT"AMPLIFIER CIRCUIT ANALYSIS"
70  PRINT""
80  PRINT"NOTE: express reflection coefficient angles as +/- <= 180 degrees in accordance with SMITH CHART usage"
90  PRINT""
100  PRINT"NOTE: enter all alpha INPUT in UPPER CASE" :PRINT""
110  INPUT "SOURCE REFLECTION COEFFICIENT       ";MS,SA
120  INPUT "LOAD REFLECTION COEFFICIENT         ";ML,AL
130  INPUT "EFFECTIVE DIELECTRIC CONSTANT       ";EP
140  INPUT "DESIGN CENTER FREQUENCY, MHZ        ";FD
150  INPUT "START FREQUENCY, MHZ                ";FL
160  INPUT "STOP FREQUENCY, MHZ                 ";FH
170  INPUT "FREQUENCY INCREMENT, MHZ            ";DF
180  INPUT "DEVICE (S) PARAMETERS AT CENTER FREQUENCY - S11,S12,S21,S22                   ";C1,C2,C3,C4,C5,C6,C7,C8
190  INPUT "ENTER (S) PARAMETERS AT SWEEP EXTREMES - Y OR N";P$
200  IF P$="N" THEN 230
210  INPUT "DEVICE (S) PARAMETERS AT START FREQUENCY - S11,S12,S21,S22                    ";L1,L2,L3,L4,L5,L6,L7,L8
220  INPUT "DEVICE (S) PARAMETERS AT STOP FREQUENCY - S11,S12,S21,S22                     ";H1,H2,H3,H4,H5,H6,H7,H8 :GOTO 250
230  L1=C1:L2=C2:L3=C3:L4=C4:L5=C5:L6=C6:L7=C7:L8=C8
240  H1=C1:H2=C2:H3=C3:H4=C4:H5=C5:H6=C6:H7=C7:H8=C8
250  INPUT "DO YOU WANT SHORT (S) OR OPEN (O) STUBS";S$
260  KS=MS*MS
270  KL=ML*ML
280  K=KS:AZ=SA
290  GOSUB 2880
300  BA=BB:L=LL:S=LS
310  K=KL:AZ=AL
320  GOSUB 2880
330  BO=BB:LO=LL:SO=LS
340  LD=30000/(2.54*FD*SQR(EP))
350  T1=S*LD
360  L9=L*LD
370  L0=LO*LD
380  T2=SO*LD
390  N=(FH-FL)/DF
400  FOR J=1 TO N+1
410  F(J)=FL+(J-1)*DF
420  IF F(J)>FD GOTO 440
430  D=L1:C=C1:G=L2:E=C2:GOTO 450
440  D=C1:C=H1:G=C2:E=H2
450  GOSUB 2810
460  M1=X:A1=Y/57.3
470  IF F(J)>FD GOTO 490
480  D=L3:C=C3:G=L4:E=C4:GOTO 500
490  D=C3:C=H3:G=C4:E=H4
500  GOSUB 2810
510  M2=X:A2=Y/57.3
520  IF F(J)>FD GOTO 540
530  D=L5:C=C5:G=L6:E=C6:GOTO 550
540  D=C5:C=H5:G=C6:E=H6
550  GOSUB 2810
560  M3=X:A3=Y/57.3
570  IF F(J)>FD GOTO 590
580  D=L7:C=C7:G=L8:E=C8:GOTO 600
590  D=C7:C=H7:G=C8:E=H8
600  GOSUB 2810
610  M4=X:A4=Y/57.3
620  B=0.000531976*F(J)*SQR(EP)
630  AR=1:AI=0
640  BR=0:BI=0
650  IF S$="O" THEN 670
660  CR=0:CI=-1/TAN(B*T1):GOTO 680
670  CR=0:CI=TAN(B*T1)
680  DR=1:DI=0
690  ER=COS(B*L9):EI=0
700  FR=0:F1=SIN(B*L9)
710  GR=0:GI=SIN(B*L9)
720  HR=COS(B*L9):HI=0
730  NR=COS(B*L0):NI=0
740  RO=0:OI=SIN(B*L0)
750  PR=0:PI=SIN(B*L0)
760  QR=COS(B*L0):QI=0
770  RR=1:RI=0
780  SR=0:SI=0
790  IF S$="O" THEN 810
800  TR=0:TI=-1/TAN(B*T2):GOTO 820
810  TR=0:TI=TAN(B*T2)
820  UR=1:UI=0
830  M=M1:A=A1 ' j element
840  GOSUB 2570
850  R=RV+1 :I=IV 'RE(1+S11), IM(1+S11)
860  GOSUB 2600
870  R1=MA :P1=AN '!1+S11!(1=S11
880  M=M4 :A=A4
890  GOSUB 2570
900  R=1-RV :I=-IV 'RE(1-S22), IM(1-S22)
910  GOSUB 2600
920  R2=MA :P2=AN '!1-S22!(1-S22
930  M=R1*R2 '!1+s11!*!1-s22!
940  A=P1+P2 '(1+s11+(1-s22
950  GOSUB 2570
960  X1=RV :Y1=IV 're(1+s11)*(1-s22), im(1+s11)*(1-s22)
970  M=M2*M3 :A=A2+A3
980  GOSUB 2570
990  X2=RV :Y2=IV 'res12*s21, ims12*s21
1000  R=X1+X2 :I=Y1+Y2
1010  GOSUB 2600
1020  JM=MA/(2*M3) '!j!(j=jm(ja
1030  JA=AN-A3
1040  M=JM :A=JA
1050  GOSUB 2570
1060  JR=RV :JI=IV
1070  M=M4 :A=A4 'k element
1080  GOSUB 2570
1090  R=RV+1 :I=IV 're(1+s22), im(1+s22)
1100  GOSUB 2600
1110  R3=MA :P3=AN '!1+s22!(1+s22
1120  M=R1*R3 '!1+s11!*!1+s22!
1130  A=P1+P3 '(1+s11 + (1+s22
1140  GOSUB 2570
1150  X3=RV :Y3=IV 're(1+s11)(1+s22), im(1+s11)(1+s22)
1160  R=X3-X2 :I=Y3-Y2
1170  GOSUB 2600
1180  KM=MA/(2*M3) '!k!(k=km(ka
1190  KA=AN-A3
1200  M=KM :A=KA
1210  GOSUB 2570
1220  KR=RV :KI=IV
1230  M=M1 :A=A1 'l element
1240  GOSUB 2570
1250  R=1-RV :I=-IV 're(1-s11), im(1-s11)
1260  GOSUB 2600
1270  R4=MA :P4=AN '!1-s11!(1-s11
1280  M=R4*R2 '!1-s11!*!1-s22!
1290  A=P4+P2 '(1-s11 + (1-s22
1300  GOSUB 2570
1310  X4=RV :Y4=IV 're(1-s11)(1-s22), im(1-s11)(1-s22)
1320  R=X4-X2 :I=Y4-Y2
1330  GOSUB 2600
1340  LM=MA/(2*M3) '!l!(l=lm(la
1350  LA=AN-A3
1360  M=LM :A=LA
1370  GOSUB 2570
1380  LR=RV :LI=IV
1390  M=R4*R3 'm element !1-s11!*!1+s22
1400  A=P4+P3 '(1-s11 + (1+s22!
1410  GOSUB 2570
1420  X5=RV :Y5=IV 're(1-s11)(1+s22), im (1-s11)(1+s22)
1430  R=X5+X2 :I=Y5+Y2
1440  GOSUB 2600
1450  MM=MA/(2*M3) '!m!(m=mm(mp
1460  MP=AN-A3
1470  M=MM :A=MP
1480  GOSUB 2570
1490  MR=RV :MI=IV
1500  ' start matrix multiplication
1510  ' load n matrix with r,s,t,u
1520  ' imaginary part of F denoted as IF, is assigned variable FI (IF is key wd)
1530  RE=RR :IE=RI :RF=SR :FI=SI
1540  RG=TR :IG=TI :RH=UR :IH=UI
1550  'load m matrix with n,o,p,q
1560  RA=NR :IA=NI :RB=RO :IB=OI
1570  RC=PR :IC=PI :RD=QR :ID=QI
1580  GOSUB 2680
1590  'load m matrix with j,k,l,m
1600  RA=JR :IA=JI :RB=KR :IB=KI
1610  RC=LR :IC=LI :RD=MR :ID=MI
1620  GOSUB 2680
1630  'load m matrix with e,f,g,h
1640  RA=ER :IA=EI :RB=FR :IB=F1
1650  RC=GR :IC=GI :RD=HR :ID=HI
1660  GOSUB 2680
1670  'load m matrix with a,b,c,d
1680  RA=AR :IA=AI :RB=BR :IB=BI
1690  RC=CR :IC=CI :RD=DR :ID=DI
1700  GOSUB 2680
1710  'calculate (s) parameters
1720  R=RE+RF+RG+RH
1730  I=IE+FI+IG+IH
1740  GOSUB 2600
1750  R5=1/MA:P5=-AN 'r5=!/(a+b+c+d)!,p5=(1/(a+b+c+d)
1760  R=RE+RF-RG-RH
1770  I=IE+FI-IG-IH
1780  GOSUB 2600
1790  S1=MA*R5 :S2=AN+P5 's11
1800  R=RE:I=IE
1810  GOSUB 2600
1820  R6=MA :P6=AN
1830  R=RH :I=IH
1840  GOSUB 2600
1850  M=MA*R6 :A=AN+P6
1860  GOSUB 2570
1870  XA=RV :YA=IV
1880  R=RF :I=FI
1890  GOSUB 2600
1900  R6=MA :P6=AN
1910  R=RG :I=IG
1920  GOSUB 2600
1930  M=MA*R6 :A=AN+P6
1940  GOSUB 2570
1950  XB=RV :YB=IV
1960  XT=XA-XB :YT=YA-YB
1970  R=XT :I=YT
1980  GOSUB 2600
1990  S3=MA*2*R5:S4=AN+P5  's12
2000  S5=2*R5 :S6=P5       's21
2010  R=-RE+RF-RG+RH
2020  I=-IE+FI-IG+IH
2030  GOSUB 2600
2040  S7=MA*R5 :S8=AN+P5   's22
2050  LF=10*LOG(S5^2)/LOG(10)
2060  IS=-10*LOG(S3^2)/LOG(10)
2070  Z1=-10*LOG(S1^2)/LOG(10)
2080  Z2=-10*LOG(S7^2)/LOG(10)
2090  IL(J)=LF
2100  RL(J)=IS
2110  IR(J)=Z1
2120  RO(J)=Z2
2130  PRINT"CALCULATING  #";J
2140  NEXT J
2150  FOR J=3 TO 5:SOUND 250*J,10:NEXT:PRINT"END OF RUN"
2160  INPUT "DO YOU WANT PLOT - Y OR N";PL$
2170  IF PL$="Y" THEN GOSUB 3380
2180  INPUT "DO YOU WANT PRINTED OUTPUT - Y OR N";PR$
2190  IF PR$="N" GOTO 3940
2200  LPRINT CHR$(14);TAB(7);"TRANSISTOR AMPLIFIER DESIGN":LPRINT""
2210  IF C$<>"Y" GOTO 2230
2220  LPRINT CHR$(14);TAB(3);"ITERATED MATCHING NETWORK PARAMETERS":LPRINT " "
2230  LPRINT ""
2240  LPRINT CHR$(14);TAB(13);"INPUT DATA":LPRINT""
2250  LPRINT TAB(5);"DESIGN CENTER FREQUENCY, FD=";FD:LPRINT""
2260  LPRINT TAB(5);"EFFECTIVE DIELECTRIC CONSTANT=";EP:LPRINT""
2270  LPRINT TAB(5);"SOURCE RC=";:LPRINT USING "#.###";MS;:LPRINT " ANG ";:LPRINT USING "###.##";SA;:LPRINT TAB(40);"LOAD RC = ";:LPRINT USING "#.###";ML;:LPRINT "  ANG  ";:LPRINT USING "###.##";AL
2280  LPRINT ""
2290  LPRINT TAB(30);"S11";TAB(41);"S12";TAB(52);"S21";TAB(62);"S22"
2300  LPRINT TAB(5);"(S) PARAMETERS @ FL=";L1;L2;L3;L4;L5;L6;L7;L8
2310  LPRINT TAB(5);"(S) PARAMETERS @ FD=";C1;C2;C3;C4;C5;C6;C7;C8
2320  LPRINT TAB(5);"(S) PARAMETERS @ FH=";H1;H2;H3;H4;H5;H6;H7;H8
2330  LPRINT "":LPRINT""
2340  LPRINT CHR$(14);TAB(10);"MATCH NETWORK DESIGN":LPRINT""
2350  LPRINT TAB(5);"INPUT STUB LENGTH (IN)=";:LPRINT USING "##.###";T1;:LPRINT TAB(40);"INPUT LINE LENGTH (IN)=";:LPRINT USING "##.###";L9
2360  LPRINT""
2370  LPRINT TAB(5);"OUTPUT LINE LENGTH (IN)=";:LPRINT USING "##.###";L0;:LPRINT TAB(40);"OUTPUT STUB LENGTH (IN)=";:LPRINT USING "##.###";T2 :LPRINT""
2380  IF S$="O" THEN 2400
2390  LPRINT TAB(5);"STUBS ARE SHORT CIRCUIT" :GOTO 2410
2400  LPRINT TAB(5);"STUBS ARE OPEN CIRCUIT"
2410  LPRINT "":LPRINT""
2420  LPRINT CHR$(14);TAB(6);"AMPLIFIER FREQUENCY RESPONSE":LPRINT""
2430  LPRINT TAB(10);"FREQ MHZ";TAB(25);"GAIN DB";TAB(40);"ISOL DB";TAB(55);"RLI DB";TAB(70);"RLO DB"
2440  LPRINT ""
2450  FOR J=1 TO N+1
2460  LPRINT TAB(10);:LPRINT USING "####.#";F(J);:LPRINT TAB(25);:LPRINT USING "##.##";IL(J);:LPRINT TAB(40);:LPRINT USING "###.##";RL(J);:LPRINT TAB(55);:LPRINT USING "##.##";IR(J);:LPRINT TAB(69);:LPRINT USING "##.##";RO(J)
2470  NEXT J
2480  LPRINT " ":LPRINT  " "
2490  INPUT "DO YOU WANT TO TUNE MATCHING NETWORK ELEMENTS - Y OR N";C$
2500  IF C$="Y" THEN 2520
2510  END
2520  INPUT "INPUT STUB LENGTH (IN)=";T1
2530  INPUT "INPUT LINE LENGTH (IN)=";L9
2540  INPUT "OUTPUT LINE LENGTH (IN)=";L0
2550  INPUT "OUTPUT STUB LENGTH (IN)=";T2
2560  GOTO 390
2570  REM polar to rectangular conversion
2580  RV=M*COS(A) :IV=M*SIN(A)
2590  RETURN
2600  REM rectangular to polar conversion
2610  MA=SQR(R^2+I^2)
2620  AN=ATN((I+0)/(R+0))
2630  IF R<0 THEN 2650
2640  GOTO 2670
2650  BN=AN+3.14159
2660  AN=BN
2670  RETURN
2680  REM load p matrix elements
2690  WR=RA*RE-IA*IE+RB*RG-IB*IG
2700  WI=RA*IE+IA*RE+RB*IG+IB*RG
2710  XR=RA*RF-IA*FI+RB*RH-IB*IH
2720  XI=RA*FI+IA*RF+RB*IH+IB*RH
2730  YR=RC*RE-IC*IE+RD*RG-ID*IG
2740  YI=RC*IE+IC*RE+RD*IG+ID*RG
2750  ZR=RC*RF-IC*FI+RD*RH-ID*IH
2760  ZI=RC*FI+IC*RF+RD*IH+ID*RH
2770  REM reload n matrix
2780  RE=WR:IE=WI:RF=XR:FI=XI
2790  RG=YR:IG=YI:RH=ZR:IH=ZI
2800  RETURN
2810  REM (s) parameter interpolation routine
2820  IF F(J)>FD GOTO 2850
2830  X=(C-D)*(F(J)-FL)/(FD-FL)+D
2840  Y=(E-G)*(F(J)-FL)/(FD-FL)+G :GOTO 2870
2850  X=(C-D)*(F(J)-FD)/(FH-FD)+D
2860  Y=(E-G)*(F(J)-FD)/(FH-FD)+G
2870  RETURN
2880  REM calculates main and stub lengths
2890  IF AZ>=0 THEN 2910
2900  AY=AZ+180 :GOTO 2920
2910  AY=AZ-180
2920  BC=SQR(8*K/(2*(1-K)))
2930  M5=(BC^4+4*BC*BC)/((4+BC*BC)^2)
2940  IF(M5-K)<0.01 THEN 2960
2950  PRINT M5;K:STOP
2960  GA=ATN(2/BC)*180/3.14159
2970  AM=ABS(AY):MG=ABS(GA)
2980  REM case I
2990  IF AY<0 THEN 3010
3000  GOTO 3090
3010  IF AM>MG THEN 3030
3020  GOTO 3200
3030  BB=-BC
3040  LL=(AM-MG)/720
3050  IF S$="O" THEN 3070
3060  LS=0.25-ATN(BC)/(2*3.14159) :GOTO 3370
3070  LS=0.5-ATN(BC)/(2*3.14159)
3080  GOTO 3370
3090  REM case II
3100  IF AY>0 THEN 3120
3110  GOTO 3200
3120  IF AM>=MG THEN 3140
3130  GOTO 3290
3140  BB=-BC
3150  LL=0.5-(MG+AM)/720
3160  IF S$="O" THEN 3180
3170  LS=0.25-ATN(BC)/(2*3.14159):GOTO 3370
3180  LS=0.5-ATN(BC)/(2*3.14159)
3190  GOTO 3370
3200  REM case III
3210  IF AY<0 THEN 3230
3220  GOTO 3290
3230  BB=BC
3240  LL=(AM+MG)/720
3250  IF S$="O" THEN 3270
3260  LS=0.25+ATN(BC)/(2*3.14159) :GOTO 3370
3270  LS=ATN(BC)/(2*3.14159)
3280  GOTO 3370
3290  REM case IV
3300  IF AY>0 THEN 3320
3310  PRINT"ERROR - NO CASE FITS":STOP
3320  BB=BC
3330  LL=(MG-AM)/720
3340  IF S$="O" THEN 3360
3350  LS=0.5-ATN(BC)/(2*3.14159):GOTO 3370
3360  LS=ATN(BC)/(2*3.14159)
3370  RETURN
3380  PRINT""
3390  PRINT"NOTE: USE GRAPHICS SCREEN DUMP FOR HARD COPY -- HIT ANY KEY TO RETURN TO  MENU" :PRINT""
3400  INPUT "PLOT WHICH PARAMETER - GAIN, INPUT RL, OUTPUT RL, ISOL ";PP$
3410  INPUT "WHAT IS MAX PLOT VALUE - dB";PM
3420  SCREEN 2,0
3430  KEY OFF
3440  VIEW (212,3)-(628,182)
3450  WINDOW (-2,-56)-(102,0)
3460  FOR J=0 TO 100 STEP 10
3470  LINE (J,0)-(J,-50)
3480  NEXT J
3490  LINE (100,-50)-(0,-50)
3500  FOR J=0 TO -50 STEP -10
3510  LINE (0,J)-(100,J)
3520  NEXT J
3530  LINE (0,0)-(0,-50)
3540  LOCATE 23,47
3550  PRINT "FREQUENCY - GHz"
3560  FOR I=0 TO 5
3570  LOCATE 1+I*4,23
3580  PRINT USING "###.#";PM*(1-I/5)
3590  NEXT I
3600  LOCATE 11,18 :PRINT "dB"
3610  FOR J=0 TO 10
3620  LOCATE 22,27+J*5
3630  Q=(INT((FL+(FH-FL)/10*J)/10))/100
3640  PRINT USING "#.##";Q
3650  NEXT J
3660  LOCATE 2,7:PRINT "TRANSISTOR"
3670  LOCATE 4,3
3680  PRINT "AMPLIFIER RESPONSE"
3690  PSET (0,-50+50/PM*IL(1))
3700  I=1
3710  CT=1
3720  FOR J=0 TO N
3730  IF PP$="GAIN" THEN 3770
3740  IF PP$="INPUT RL" THEN 3790
3750  IF PP$="OUTPUT RL" THEN 3800
3760  IF PP$="ISOL" THEN 3810
3770  IF IL(J+1)<0 GOTO 3830
3780  LINE -(J*100/N,-50+50/PM*IL(I)):LOCATE 9,17:PRINT "GAIN" :LOCATE 19,7:PRINT "FIGURE 1":GOTO 3820
3790  LINE -(J*100/N,-50+50/PM*IR(I)):LOCATE 9,17:PRINT "RL IN" :LOCATE 19,7:PRINT "FIGURE 2":GOTO 3820
3800  LINE -(J*100/N,-50+50/PM*RO(I)):LOCATE 9,16:PRINT "RL OUT" :LOCATE 19,7:PRINT "FIGURE 3":GOTO 3820
3810  LINE -(J*100/N,-50+50/PM*RL(I)):LOCATE 9,17:PRINT "ISOL" :LOCATE 19,7:PRINT "FIGURE 4"
3820  I=I+1
3830  NEXT J
3840  A$=INKEY$
3850  IF LEN(A$)=0 THEN 3840
3860  SCREEN 0,0
3870  KEY ON
3880  INPUT  "DO YOU WANT OTHER PLOT - Y OR N";B$
3890  IF B$="N" THEN 3900 ELSE 3400
3900  INPUT "DO YOU WANT PRINTED OUTPUT - Y OR N";PR$
3910  IF PR$="Y" GOTO 2200
3920  INPUT "DO YOU WANT TO TUNE MATCHING NETWORK ELEMENTS -                     Y OR N";C$
3930  IF C$="Y" THEN 2520
3940  END
